/*
	gui.cpp
	fudroyd sdl gui
	/mic 2009
*/

#include "gui.h"


char szFileNameOnly[256];
int limitFps = 1;
SDL_Surface *surface;
unsigned char palette[16];
Uint32 lastTime;
input_event ie;


void gui_init() {
	SDL_Init(SDL_INIT_VIDEO | SDL_INIT_TIMER);

	if ((surface = SDL_SetVideoMode(320, 240, 8, SDL_SWSURFACE)) == NULL)
	{
		fprintf(stderr,"ERROR: SDL_SetVideoMode\n");
	}

	// Set up the palette for the monochrome gameboy
	palette[0] = 225; palette[1] = 248; palette[2] = 200;
	palette[4] = 134; palette[5] = 192; palette[6] = 128;
	palette[8] = 12; palette[9] = 102; palette[10] = 93;
	palette[12] = 8; palette[13] = 24; palette[14] = 0;
	SDL_SetPalette(surface, SDL_LOGPAL|SDL_PHYSPAL, (SDL_Color*)(&palette[0]), 0, 4);

	andkeys_open();

	lastTime = SDL_GetTicks();
}


void gui_close() {
}


void gui_process() {
	if (andkeys_get(&ie)) {
		if (ie.value == 1) {
			// Key pressed
			switch (ie.code) {
				case 106:				// Right
					keys &= ~0x01;
					break;
				case 105:				// Left
					keys &= ~0x02;
					break;
				case 103:				// Up
					keys &= ~0x04;
					break;
				case 108:				// Down
					keys &= ~0x08;
					break;
				case 44:				// Z
					keys &= ~0x20;
					break;
				case 45:				// X
					keys &= ~0x10;
					break;
				case 28:				// Return
					keys &= ~0x80;
					break;
			}
		} else if (ie.value == 0) {
			// Key released
			switch (ie.code) {
				case 106:
					keys |= 0x01;
					break;
				case 105:
					keys |= 0x02;
					break;
				case 103:
					keys |= 0x04;
					break;
				case 108:
					keys |= 0x08;
					break;
				case 44:
					keys |= 0x20;
					break;
				case 45:
					keys |= 0x10;
					break;
				case 28:
					keys |= 0x80;
					break;
			}
		}

	}
}


void gui_present(unsigned char *vscreen) {
	int i,j;

	SDL_LockSurface(surface);
	unsigned char *dest = (unsigned char *)surface->pixels;
	dest += surface->pitch * 48 + 80;

	if (limitFps) {
		while ((SDL_GetTicks() - lastTime) < 16) {}
		lastTime = SDL_GetTicks();
	}

	for (i=0; i<144; i++)
	{
		for (j=0; j<160; j++)
		{
			dest[j] = vscreen[j];
		}
		dest += surface->pitch;
		vscreen += 160;
	}

	SDL_UnlockSurface(surface);
	SDL_Flip(surface);
}
