#ifndef __MEMORY_H__
#define __MEMORY_H__

#include "stdafx.h"

extern unsigned char IME,REG_IE;
extern unsigned char RAM[0x2000],VRAM[0x2000],OAM[0xA0],IOREGS[0x4C],HIRAM[0x80];

#define CART_TYPE cart[0x147]

#define TYPE_MBC1 1
#define TYPE_MBC1_RAM 2
#define TYPE_MBC1_RAM_BATT 3
#define TYPE_MBC2 5
#define TYPE_MBC2_BATT 6
#define TYPE_MBC3 17
#define TYPE_MBC3_RAM 18
#define TYPE_MBC3_RAM_BATT 19


#define REG_DIV  IOREGS[0x04]
#define REG_TIMA IOREGS[0x05]
#define REG_TMA  IOREGS[0x06]
#define REG_TAC  IOREGS[0x07]
#define REG_IF   IOREGS[0x0F]
#define REG_LCDC IOREGS[0x40]
#define REG_STAT IOREGS[0x41]
#define REG_SCY  IOREGS[0x42]
#define REG_SCX  IOREGS[0x43]
#define REG_LY   IOREGS[0x44]
#define REG_LYC  IOREGS[0x45]
#define REG_BGP  IOREGS[0x47]
#define REG_OBP0 IOREGS[0x48]
#define REG_OBP1 IOREGS[0x49]
#define REG_WY   IOREGS[0x4A]
#define REG_WX   IOREGS[0x4B]


extern int mem_reset();
extern unsigned char mem_read_8(unsigned short);
extern unsigned short mem_read_16(unsigned short);
extern void mem_write_8(unsigned short,unsigned char);
extern void mem_write_16(unsigned short,unsigned short);
extern void mem_key_down();

#endif
